#ifndef __box_widget_h__
#define __box_widget_h__

#include "widget.h"

#include <vector>

enum class BoxWidgetOrientation {
    HORIZONTAL,
    VERTICAL,
};

class BoxWidget : public Widget {
    public:
        BoxWidget(BoxWidgetOrientation oritentation);

        size_t add_child(const std::shared_ptr<Widget> &child);
        void remove_child(size_t position);
        Widget *get_child(size_t position) const;

        virtual void request_size(WidgetSize &size, const WidgetSize &hint);
        virtual void draw(SDL_Renderer *renderer, const WidgetDrawLocation &location);

    private:
        BoxWidgetOrientation m_orientation;
        std::vector<std::shared_ptr<Widget>> m_children;
        std::vector<WidgetSize> m_children_sizes;
};

#endif //#ifndef __box_widget_h__

