#include "color_widget.h"

#include "logging/logging.h"

ColorWidget::ColorWidget(uint8_t r, uint8_t g, uint8_t b, uint8_t a) {
    m_color = {r, g, b, a};
}

void ColorWidget::request_size(WidgetSize &size, const WidgetSize &hint) {
    size = hint;
}

void ColorWidget::draw(SDL_Renderer *renderer, const WidgetDrawLocation &location) {
    SDL_Rect rect;
    rect.x = location.x;
    rect.y = location.y;
    rect.w = location.size.width;
    rect.h = location.size.height;

    SDL_SetRenderDrawColor(renderer, m_color.r, m_color.g, m_color.b, m_color.a);
    SDL_RenderFillRect(renderer, &rect);
}
