#include "fixed_widget.h"

#include "logging/logging.h"

#include <cassert>

FixedWidget::FixedWidget(int width, int height) {
    set_size(width, height);
}

void FixedWidget::set_size(int width, int height) {
    assert(width >= 0 && height >= 0);

    m_width = width;
    m_height = height;
}

void FixedWidget::request_size(WidgetSize &size, const WidgetSize &hint) {
    static_cast<void>(hint);

    size.width = m_width;
    size.height = m_height;
}

void FixedWidget::draw(SDL_Renderer *renderer, const WidgetDrawLocation &location) {
    if (!m_child)
        return;

    m_child->draw(renderer, location);
}

