#include "imu.h"

#include <arpa/inet.h>

IMU_Datum imu_datum_unpack(const uint8_t *buf) {
    IMU_Datum datum;

    datum.heading   = 360.0 * (double)ntohs(*(uint16_t *)&buf[0]) / UINT16_MAX;
    datum.roll      = 360.0 * (double)ntohs(*(uint16_t *)&buf[2]) / UINT16_MAX - 90.0;
    datum.pitch     = 360.0 * (double)ntohs(*(uint16_t *)&buf[4]) / UINT16_MAX - 180.0;
    datum.cal       = buf[6] & 0x02;
    datum.lia[0]    = (int8_t)buf[7] / (double)INT8_MAX * 2.0;
    datum.lia[1]    = (int8_t)buf[8] / (double)INT8_MAX * 2.0;
    datum.lia[1]    = (int8_t)buf[9] / (double)INT8_MAX * 2.0;
    datum.timestamp = ntohl(*(uint32_t *)&buf[10]);

    return datum;
}

