#ifndef __indicator_widget_h__
#define __indicator_widget_h__

#include "widget.h"

#include <SDL2/SDL.h>

#include <string>

enum class IndicatorWidgetColor {
    GREEN  = 0,
    ORANGE = 1,
    RED    = 2,

    N_COLORS
};

class IndicatorWidget : public Widget {
    public:
        IndicatorWidget(const std::string &indicator);
        virtual ~IndicatorWidget();

        void set_color(IndicatorWidgetColor color);
        IndicatorWidgetColor get_color() const;

        void turn_on();
        void turn_off();
        void blink();

        virtual void request_size(WidgetSize &size, const WidgetSize &hint);
        virtual void draw(SDL_Renderer *renderer, const WidgetDrawLocation &location);

    private:
        SDL_Surface *m_img;
        SDL_Texture *m_texture;

        IndicatorWidgetColor m_color;

        bool    m_state;
        Uint32  m_timer;
};

#endif //#ifndef __indicator_widget_h__
