#ifndef __iocontroller_h__
#define __iocontroller_h__

#include "program.h"

#include "network/network.h"
#include "network/network_types.h"

#include <SDL2/SDL.h>

#include <cstdint>

const int TICK_RATE = 144;  // Ticks per second
const int SEC_PER_TICK = 1000 / TICK_RATE;

class IOController {
    public:
        IOController(Program *const p, Network *const n);

        IOController(const IOController &) = delete;
        IOController &operator=(const IOController &) = delete;

        void main_loop();

    private:
        Program *const program;
        Network *const network;

        double m_map_pan_dx;
        double m_map_pan_dy;

        int m_prev_motor_left;
        int m_prev_motor_right;
};

#endif  // __iocontroller_h__
