#ifndef __layout_widget_h__
#define __layout_widget_h__

#include "widget.h"

#include <memory>

enum class LayoutWidgetPlacement {
    CENTER          = 0,
    TOP_LEFT        = 1,
    TOP_RIGHT       = 2,
    BOTTOM_LEFT     = 3,
    BOTTOM_RIGHT    = 4,

    N_PLACEMENTS
};

class LayoutWidget : public Widget {
    public:
        LayoutWidget();

        void add_child(std::shared_ptr<Widget> widget, LayoutWidgetPlacement placement);
        void remove_child(LayoutWidgetPlacement placement);
        Widget *get_child(LayoutWidgetPlacement placement) const;

        virtual void request_size(WidgetSize &size, const WidgetSize &hint);
        virtual void draw(SDL_Renderer *renderer, const WidgetDrawLocation &location);

    private:
        std::shared_ptr<Widget> m_children[5];
        WidgetSize              m_children_sizes[5];
};

#endif //#ifndef __layout_widget_h__
