#ifndef __radar_widget_h__
#define __radar_widget_h__

#include "lidar_data.h"
#include "texture_component.h"
#include "widget.h"

#include <SDL2/SDL.h>

#include <vector>

class RadarWidget : public Widget, public TextureComponent {
    public:
        RadarWidget(double camera_angle, double robot_size);

        void set_scale(double scale);
        double get_scale() const;

        void push_lidar_data(const std::vector<LidarData> &data);

        virtual void request_size(WidgetSize &size, const WidgetSize &hint);
        virtual void draw(SDL_Renderer *renderer, const WidgetDrawLocation &location);

    private:
        double m_camera_angle;
        double m_robot_size;
        double m_scale;
        std::vector<LidarData> m_data;
};

#endif //#ifndef __radar_widget_h__
