#ifndef __streamer_widget_h__
#define __streamer_widget_h__

#include "streamer.h"
#include "texture_component.h"
#include "widget.h"

#include <SDL2/SDL.h>

class StreamerWidget: public Widget, public TextureComponent {
    public:
        StreamerWidget();

        void set_streamer(Streamer *streamer);
        Streamer *get_streamer() const;

        virtual void request_size(WidgetSize &size, const WidgetSize &hint);
        virtual void draw(SDL_Renderer *renderer, const WidgetDrawLocation &location);

    private:
        Streamer    *m_streamer;

        void update_texture(SDL_Renderer *renderer, const StreamerFrame &frame);
};

#endif //#ifndef __streamer_widget_h__
