#ifndef __widget_h__
#define __widget_h__

#include <SDL2/SDL.h>

#include <memory>

struct WidgetSize {
    int width;
    int height;
};

struct WidgetDrawLocation {
    int         x;
    int         y;
    WidgetSize  size;
};

class Widget {
    public:
        Widget() {};
        virtual ~Widget() {};

        Widget(const Widget &) = delete;
        Widget &operator=(const Widget &w) = delete;

        virtual void request_size(WidgetSize &size, const WidgetSize &hint) = 0;
        virtual void draw(SDL_Renderer *renderer, const WidgetDrawLocation &location) = 0;
};

template <typename T>
std::shared_ptr<Widget> widget_cast(const std::shared_ptr<T> &widget) {
    return std::dynamic_pointer_cast<Widget>(widget);
}

#endif //#ifndef __widget_h__
