#ifndef __except_h__
#define __except_h__

#include <cstdio>
#include <cstring>
#include <stdexcept>
#include <string>

class FloorMapExcept: public std::runtime_error {
    public:
        FloorMapExcept(const std::string &msg) : std::runtime_error(msg) {};
};

inline std::string __ex_msg(const char *file, int line, const char *func, const std::string &msg) {
    char buf[512];
    snprintf(buf, sizeof(buf), "%s:%s:%d %s", file, func, line, msg.c_str());

    return buf;
}

#define ex_msg(msg)     __ex_msg(__FILE__, __LINE__, __FUNCTION__, (msg))
#define FM(msg)         FloorMapExcept(ex_msg((msg)))
#define FM_SYS(sys)     FloorMapExcept(ex_msg(std::string(sys) + "(): " + strerror(errno)))

#endif //#ifndef __except_h__
