#ifndef __misc_h__
#define __misc_h__

#include <Eigen/Dense>

struct CompareVec {
    bool operator()(Eigen::Vector2i a, Eigen::Vector2i b) const {
        if (a[1] == b[1])
            return a[0] < b[0];
        return a[1] < b[1];
    }
};

inline Eigen::Vector2d mul_m3_v2(const Eigen::Matrix3d &mat, const Eigen::Vector2d &vec) {
    Eigen::Vector3d v3(vec[0], vec[1], 1.0);
    Eigen::Vector3d out = mat * v3;
    return Eigen::Vector2d(out[0], out[1]);
}

#endif //#ifndef __misc_h__
