#ifndef __passes_h__
#define __passes_h__

#include <Eigen/Dense>

#include "imu_data.h"
#include "point_cloud.h"
#include "grid_map.h"
#include "rect.h"

// Point cloud aligment
double align_pc_to_gm2(const GridMap *gm, const PointCloud *pc, Eigen::Matrix3d &t);

// IMU passes

double pass_imu_max_heading_vel(const IMUData &imu_data, uint64_t begin, uint64_t end);
double pass_imu_max_pr_vel(const IMUData &imu_data, uint64_t begin, uint64_t end);

// Point cloud passes

void pass_pc_clamp(PointCloud &pc, double min_r, double max_r);
void pass_pc_imu_correct(PointCloud &pc, const IMUData &imu_data);

// Gridmap passes

void pass_gm_insert_pc(GridMap &gm, const PointCloud &pc);
void pass_gm_insert_pc(GridMap &gm, const PointCloud &pc, const Rect &rect);
void pass_gm_floodfill_clean(GridMap &gm, double factor, double threshold);

#endif //#ifndef __passes_h__
