#ifndef __battery_h__
#define __battery_h__

#include <chrono>

class Battery {
    public:
        Battery();

        bool should_push();
        void push_voltage(double voltage);

        double get_voltage();
        bool get_brownout();
        bool get_level(double &level);

    private:
        double m_voltage;
        bool m_voltage_reported;
        bool m_brownout;
        bool m_brownout_reported;

        double m_sum;
        int m_count;
        std::chrono::high_resolution_clock::time_point m_next_push;
};

#endif //#ifndef __battery_h__
