#ifndef __rpcamera_h__
#define __rpcamera_h__

#include <stdexcept>
#include <sys/types.h>

class RPCameraException : public std::runtime_error {
    public:
        explicit RPCameraException(const std::string& what_arg) :
            std::runtime_error(what_arg) {}
        explicit RPCameraException(const char *what_arg) :
            std::runtime_error(what_arg) {}
};

class RPCamera {
    public:
        RPCamera(int width, int height, int fps);
        ~RPCamera();

        RPCamera(const RPCamera &) = delete;
        RPCamera &operator=(const RPCamera &) = delete;

        void get_data(void *buf, size_t &size);

    private:
        bool raspivid_alive();

        pid_t m_raspivid;
        int m_pipeout;
};

#endif //#ifndef __rpcamera_h__
