#ifndef __rplidar_h__
#define __rplidar_h__

#include <cstdlib>
#include <rplidar.h>

#include <stdexcept>

const int RP_LIDAR_MAX_POINTS = 8192;

class RPLidarException : public std::runtime_error {
    public:
        explicit RPLidarException(const std::string& what_arg) :
            std::runtime_error(what_arg) {}
        explicit RPLidarException(const char *what_arg) :
            std::runtime_error(what_arg) {}
};

struct RPLidarPoint {
    uint16_t angle;
    uint16_t distance;
};

class RPLidar {
    public:
        RPLidar(const char *dev);
        ~RPLidar();

        RPLidar(const RPLidar &obj) = delete;
        RPLidar &operator=(const RPLidar &obj) = delete;

        void get_points(RPLidarPoint *points, size_t &size);

    private:
        void clean_up();

        rp::standalone::rplidar::RPlidarDriver *m_driver;
};

#endif //#ifndef __rplidar_h__
