#ifndef __thunder_borg_h__
#define __thunder_borg_h__

#include <cstdint>
#include <cstdlib>

class ThunderBorg {
    public:
        ThunderBorg(const char *i2c_dev, uint32_t addr);
        ~ThunderBorg();

        ThunderBorg(const ThunderBorg &) = delete;
        ThunderBorg &operator=(const ThunderBorg &) = delete;

        void set_motors(double speed);
        void set_motor_a(double speed);
        void set_motor_b(double speed);

        double get_battery_voltage();

    private:
        void i2c_send(uint8_t command);
        void i2c_send_u8(uint8_t command, uint8_t data);
        void i2c_recv(uint8_t command, uint8_t *buf, size_t size);
        uint8_t i2c_recv_u8(uint8_t command);
        uint16_t i2c_recv_u16(uint8_t command);

        void stop_all();

        int m_fd;
};

#endif //#ifndef __thunder_borg_h__
